/*
  otak project.
  copyright (C) 2002 
  grzegorz moskal,  <g.moskal@opengroup.org>
  license : gnu gpl version 2 			*/

#define BASE_C_
#define BASE_FRIEND_
#include "base.h"

static struct man *mj;
static struct drawer *dj;
static struct item *ij;

static int caption_length(char *s)
{
	char *j = s;
	while (*j && *j != ',')
		j++;
	return j - s;
}

static char *return_caption(char *s)
{
	int len;
	char *ret = 0;
	if ((len = caption_length(s))) {
		ret = strncpy(xmalloc(sizeof(char) * (len+1)), s, len);
		ret[len] = 0;
	}
	return ret;
}

void put_item(struct drawer *d, char *caption)
{
	ij = xmalloc(sizeof(struct item));
	ij->next = 0;
	ij->caption = (caption) ? strdup(caption) : caption;

	if (!d->first)
		d->first = d->last = ij;
	else {
		d->last->next = ij;
		d->last = ij;
	}
}

void add_drawer(struct man *p, struct stanza *s, char *whole)
{
	char *caption; 
	int len;
	if (!p || !s || !whole)
		return;
	dj = xmalloc(sizeof(struct drawer));
	dj->next = 0;
	dj->first = dj->last = 0;
	dj->pattern = s;
	
	if (!p->first)
		p->first = p->last = dj;
	else {
		p->last->next = dj;
		p->last = dj;
	}
		
	while (*whole) 
		if ((caption = return_caption(whole))) {
			len = strlen(caption);
			whole += len;
			put_item(p->last, caption);
			if (*whole)
				whole++;
		}
}

void add_man(struct man *p) 
{
	if (!p)
		return;

	if (!first_man)
		first_man = last_man = current_man = p;
	else {
		last_man->next = p;
		last_man = p;
	}
}

static struct man *init_man(struct ecl_stanza *ecl_s)
{
	struct man *m = NULL;
	struct ecl_caption *ecl_c;
	struct stanza *s;

	for (ecl_c = ecl_s->head; ecl_c; SWITCH(ecl_c)) {
		if ((s = find_stanza_by_name(ecl_c->name)) == NULL)
			continue;

		if (m == NULL) 
			m = XALLOC(man);

		add_drawer(m, s, ecl_c->value);
	}
	return m;
}

void add_new_man(void)
{
	add_man(XALLOC(man));
}

int read_base(char *name)
{
	struct ecl_file *file;
	struct ecl_stanza *ecl_s;

	struct man *m;

	if (name == NULL) 
		return 0;

	
	if ((file = ecl_file_open(name)) == NULL)
		return 0;

	ecl_file_init(file);			

	msgf("read in base file:         '%s'", name);

	for (ecl_s = file->head; ecl_s; SWITCH(ecl_s))
		if ((m = init_man(ecl_s)))
			add_man(m);

	ecl_file_close(file);

	return 1;
}
